{% extends "base.html" %}
{% load static %}
{% load extra_tags %}

{% block title %} Message {% endblock %}
{% block titleHeader %}Messages{% endblock %}
{% block titleSubHeader %} Messages to users{% endblock %}
{% block libraries %}
<!-- editoJS -->
<script src="https://cdn.jsdelivr.net/npm/editorjs-html@3.4.0/build/edjsHTML.js"></script>
{% endblock %}

{% block content %}
<div class="container">

    <div class="row">
        <div class="col-md-2">
            <p><b>Search</b></p>
            <input type="text" id="myFilter" class="form-control" onkeyup="myFunction()" placeholder="Search a message...">
            <br>
            <p><b>Filters</b></p>
            <div class="d-grid gap-2">
                {% for c in cat %}
                <a class="btn {% if c == cat_user %}btn-secondary {% else %} btn-outline-secondary{% endif %}" aria-current="page" href="{% url 'messageUser_page' cat_user=c %}">{{c|capfirst}}</a>
                {% endfor %}
                <a class="btn {% if not cat_user %}btn-secondary {% else %} btn-outline-secondary{% endif %}" href="{% url 'messageUser_page' %}" role="button"> All</a>
            </div>

            <div class="d-grid mt-2">
                <a href="{% url 'messageUser_archive_page' %}" class="btn btn-light"><i class="fa-solid fa-box-archive"></i> Go to Archive</a>
            </div>

            {% if request.user.is_superuser %}
            <div class="d-grid mt-2">
                <a href="{% url 'manage_message' mode='create' %}" class="btn btn-primary"><i class="fa-solid fa-envelope"></i> Create message</a>
            </div>
            {% endif %}
        </div>
        <div class="col-md-10">
            {% if listMessage|length == 0 %}
            <div class="alert alert-primary" role="alert">
              <i class="me-2 fa-solid fa-circle-info"></i> No message at the moment.
            </div>
            {% else %}
            <div id="myMessages">
            {% for m in listMessage %}
            <div class="card mb-3">
              <div class="card-header {{ m.messageColor }}">
                <span class="me-2">{{ m.messageIcon|safe }}</span>{{ m.messageTitle }}
              </div>
              <div class="card-body">
                {{ m.messageAbstract|markdown_to_html|safe }}
                 <div class="d-grid gap-2 d-md-flex justify-content-md-end mb-2">
                     {% if request.user.is_superuser %}
                     <a href="{% url 'manage_message' mode='delete' idMessage=m.id %}" class="btn btn-danger"><i class="fa-solid fa-circle-xmark"></i> Delete</a>
                     <a href="{% url 'manage_message' mode='archive' idMessage=m.id %}" class="btn btn-warning"><i class="fa-solid fa-box-archive"></i> Archive</a>
                     <a href="{% url 'manage_message' mode='edit' idMessage=m.id %}" class="btn btn-success"><i class="fa-solid fa-pen"></i> Edit</a>
                     {% endif %}
                     <a href="{% url 'messageContent_page' idMessage=m.id %}" class="btn btn-primary"><i class="fas fa-search"></i> Read more</a>
                 </div>
              </div>
              <div class="card-footer text-muted">
                {{ m.messageDateCreation }}
              </div>
            </div>
            {% endfor %}
            </div>
            {% endif %}
        </div>
    </div>
</div>

<script>
function myFunction() {
    var input, filter, cards, cardContainer, title, i, description;
    input = document.getElementById("myFilter");
    filter = input.value.toUpperCase();
    cardContainer = document.getElementById("myMessages");
    cards = cardContainer.getElementsByClassName("card");

    for (i = 0; i < cards.length; i++) {
        title = cards[i].querySelector(".card-header");
        description = cards[i].querySelector(".card-body");

        if ( title.innerText.toUpperCase().indexOf(filter) > -1 || description.innerText.toUpperCase().indexOf(filter) > -1) {
            cards[i].style.display = "";
        } else {
          cards[i].style.display = "none";
        }
    }
}
</script>
{% endblock %}